/*
 * append - creates a compilation of goomba v2.23 compliant borders for
 * appending/prepending Copyright (C) 2005 Kuwanger
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 675 Mass
 * Ave, Cambridge, MA 02139, USA.
 * 
 * History
 * v1.0 - Aug 22, 2005 - Initial Release
 * v1.1 - Sep 10, 2005 - Support a fully transparent image (supply "-")
 */

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.File;

class append {

     public static void main(String argv[]) throws IOException, FileNotFoundException, IncorrectDimensionsException, InvalidRGBException, TooManyColorsException, TooManyTilesException {
    	final int borderid = 0x789b4987;
        int argc = argv.length;

    	if (argc >= 1 && (argc % 2 == 1))
    	{
        	int count, cfont_size, cscreen_size, total_size;
        	char[] cfont, cscreen;
        	char[] palette;
        	LESimpleDataOutputStream out = new LESimpleDataOutputStream(argv[0]);
    		String title;
    		
    		out.writeInt(borderid);
    		count = (argc - 1) >> 1;
    		out.writeInt(count);
    		
    		for (int a = 1; a < argc; a += 2) {
			BorderImage b;
			if (argv[a].equals("-"))
				b = new BorderImage();
			else
    				b = new BorderImage(javax.imageio.ImageIO.read(new File(argv[a])));
    			 
    			cfont = LZ77.Compress(b.getTilesBytes());
    			cfont_size = cfont.length;
    			palette = b.getPaletteChars();
    			cscreen = LZ77.Compress(b.getScreenChars());
    			cscreen_size = cscreen.length;
    			
    			total_size = cfont_size + cscreen_size + 24 + 4 + 32 + 4;
    			out.writeInt(total_size);
    			out.writeString(argv[a+1], 24);
    			out.writeInt(cfont_size + 4);
    			out.writeBytes(cfont);
    			out.writeChars(palette);
    			out.writeBytes(cscreen);
    		}
    		out.close();
    		System.exit(0);
    	} else {
    		System.out.println("Usage: [java] append <out_bound> <image1> <image1 title> ...");
    		System.exit(1);
    	}
    }
}
